/*
 * Page navigation functions
 *
 * Requires:
 *   - appuntat.global.js
 */

var ctPagetypeDetail = "PAGETYPE_DETAIL";
var ctPagetypeEdit = "PAGETYPE_EDIT";

// Gets the html page name for the given profile and type
function navGetPage( profileType, pageType ){
    var page;
    if( pageType == ctPagetypeDetail ){
        page = "detall";
    }else if( pageType == ctPagetypeEdit ){
        page = "editar";
    }else{
        console.error("Unknown requested page type " + pageType);
        return "404.html";
    }
    if( profileType == ctProfileTypeEvent ){
        page += "Esdeveniment.html";
    }else if( profileType == ctProfileTypeSportist ){
        page += "Esportista.html";
    }else if( profileType == ctProfileTypeLocation ){
        page += "Instalacio.html";
    }else{
        console.error("Unknown requested profile type " + profileType);
        return "404.html";
    }
    return page;
}

// goto index page
function gotoIndex(){
    window.location = ctFrontendRootURL.concat("/index.html");
}

// Redirects to the detail page of the specified Profile
// Params:
//    - profileId: The ID of the profile to load
//    - profileType: the TYPE of the profile to load
function gotoProfileDetailPage( profileId, profileType ){
    var detailPage = navGetPage( profileType, ctPagetypeDetail );
    var newLocation = ctFrontendRootURL + "/" + detailPage + "?id=" + profileId;
    window.location = newLocation;
}

// Redirects to the edit page of the specified Profile
function gotoProfileEditPage( profileId, profileType ){
    var editPage = navGetPage( profileType, ctPagetypeEdit );
    var newLocation = ctFrontendRootURL + "/" + editPage + "?id=" + profileId;
    window.location = newLocation;    
}

// Redirects to the create-new page for the specified Profile
function gotoProfileCreatePage( profileType, requesterProfileId, requesterProfileType, requesterProfileName ){
    var createPage = navGetPage( profileType, ctPagetypeEdit );
    var newLocation = ctFrontendRootURL + "/" + createPage;
    newLocation += "?requesterProfileId=".concat(requesterProfileId);
    newLocation += "&requesterProfileType=".concat(requesterProfileType);
    newLocation += "&requesterProfileName=".concat(requesterProfileName);
    window.location = newLocation;    
}

