/*
 * Profile management
 *
 * Requires:
 *  - appuntat.global.js
 *  - jquery.ui.js
 */

// Profile creation
// Requires:
//  - a div "divProgressBar" with a progress bar in it
//  - the form with the user/profile data
function pmCreateProfile( createdUserId ){
    $( "#divProgressBar" ).progressbar({ value: 60 });
    var formAction = ctBackendRootURL;
    if( $( '#selProfile' ).val() == "sportist" ){
        formAction = formAction + "/updateSportist";
    }else{
        formAction = formAction + "/updateLocation";
    }
    var formData = {
        name: $('#txtRegisterName').val(),
        managerId: createdUserId
    }
    $.post( formAction, formData, pmCreateProfileCallback );
};
var pmCreateProfileCallback = function( response ){
    if($.isEmptyObject( response.result )){
        gfShowMessage( "No s'ha pogut crear el perfil associat a l'usuari: " + response.errorMessage, true );
    }else{
        gfShowMessage("Usuari registrat correctament, ja pots iniciar sessio.", false);
    }
};

// Redirects to the home page of the current logged user
function pmGotoProfileHome(){
    var profileId = gfGetGlobalValue( ctKeyProfileId );
    var profileType = gfGetGlobalValue( ctKeyProfileType );
    gotoProfileDetailPage( profileId , profileType );
}

// Returns TRUE if the logged profile is the manager of the profile being shown
function pmProfileViewerIsItsManager(){
    var urlParams = gfQueryStringToJSON( location.search.slice(1) );
    var loggedProfileId = gfGetGlobalValue( ctKeyProfileId );
    return ( urlParams.id == loggedProfileId );
}

// Updates the picture defined for the current profile
// Params:
// - imageData: The image data (loaded by gfReadImage)
// Requires:
// - The form 'frmPicture' with the chosen picture
// - The div 'divProgressBar'
function pmUploadPicture( fileSelect ) {
    var file = fileSelect.files[0];
    console.log( fileSelect.files.length );
    if( file != null && file != undefined){
        $('#mdlProgress').foundation('reveal', 'open');
        $( "#divProgressBar" ).progressbar({ value: 10 });
        var formData = new FormData();
        formData.append('images[]', file, file.name);
        formData.append("id", gfGetGlobalValue( ctKeyProfileId ) );
        formData.append("profileType", gfGetGlobalValue( ctKeyProfileType ) );
        var formAction = ctBackendRootURL + "/uploadProfilePicture";
        $( "#divProgressBar" ).progressbar({ value: 50 });
        $.ajax({
            url: formAction,
            type: 'POST',
            data: formData,
            async: true,
            cache: false,
            contentType: false,
            processData: false,
            success: function(response){
                pmLoadPicture( response.result.pictureId , gfGetGlobalValue(ctKeyProfileType) );
                gfShowMessage( "Imatge de perfil actualitzada.", false );
            },
            error: function( response ){
                gfShowMessage( "No s'ha pogut actualitzar la imatge de perfil.", true );
            }
        });
    }
}

// Sets the profile picture obtaining the raw data from the server
// Params:
//    - fileId : The picture id as defined in the profile entity
//    - prpfileType : the type of profile to load the picture for
// Requires:
//   -  The target divs 'divProfileCaptionSmall' , 'divProfileCaptionMedium' , 'divProfileCaptionLarge'
function pmLoadPicture( fileId, profileType ){    
    var imgSrc = null;    
    if( fileId == null ){        
        if( profileType == ctProfileTypeEvent ) {
            imgSrc = 'img/profile_event.jpg';
        } else if( profileType == ctProfileTypeSportist ) {
            imgSrc = 'img/profile_sportist.jpg';
        } else if( profileType == ctProfileTypeLocation ) {
            imgSrc = 'img/profile_location.jpg';
        }        
    }else{
        imgSrc = ctBackendRootURL + "/getProfilePicture?id="+fileId;
    }
    $('#divProfileCaption').css("background-image", "url("+imgSrc+")");
}