/*
 * Search page functions
 *
 * Requires:
 *   - appuntat.*.js
 */

// Sets the visibility of the components
function schSetInitialCompsVisibility(){
    // search results table
    $('#divResults').addClass("hide");
    // filter options
    $('#selProfileType').append($('<option>', { value: undefined }).text("-"));
    $('#selProfileType').append($('<option>', { value: ctProfileTypeEvent }).text("Esdeveniment"));
    $('#selProfileType').append($('<option>', { value: ctProfileTypeLocation }).text("Instalacio"));
    $('#selProfileType').append($('<option>', { value: ctProfileTypeSportist }).text("Esportista"));
    // hide all dependent opions
    $('#lblDate').addClass("hide");
    $('#lblAddress').addClass("hide");
}

// Searchs and displays result
// Requires:
//    - xxx
function schSearch(){
    var searchParams = schGatherSearchParams();
    if( searchParams.profileType != undefined ){
        schConfigureResultsTable( searchParams );
        schPerformSearch( searchParams );       
        $('#divResults').removeClass("hide");
    }
}

// Gathers the filter chriteria from the filter comps
// Returns:
//    - xxx
// Requires:
//    - xxx
function schGatherSearchParams(){
    var searchParams = {};
    searchParams.profileType = $('#selProfileType').val();
    if( $('#txtName').val().length>1 ) searchParams.name = $('#txtName').val();
    if( $('#txtAddress').val().length>1 ) searchParams.address = $('#txtAddress').val();
    if( searchParams.profileType == ctProfileTypeEvent ){
        if($('#txtDateFrom').val().length>0) searchParams.dateFrom = $('#txtDateFrom').val();
        if($('#txtDateTo').val().length>0) searchParams.dateTo = $('#txtDateTo').val();
    }
    return searchParams;
}

// Configures the reslts table headers
// Requires:
//    - xxx
function schConfigureResultsTable( searchParams ){
    $('#divEventsList').addClass("hide");
    $('#divLocationsList').addClass("hide");
    $('#divSportistsList').addClass("hide");
    if( searchParams.profileType == ctProfileTypeEvent ){
        $('#divEventsList').removeClass("hide");
    }else if( searchParams.profileType == ctProfileTypeLocation ){
        $('#divLocationsList').removeClass("hide");
    }else if( searchParams.profileType == ctProfileTypeSportist ){
        $('#divSportistsList').removeClass("hide");
    }
}


// Performs the actual search
// Params:
//    - xxx
// Requires:
//    - xxx
function schPerformSearch( searchParams ){
    
    var tableId;
    if( searchParams.profileType == ctProfileTypeEvent ){
        tableId = "tblEvents";
    }else if( searchParams.profileType == ctProfileTypeLocation ){
        tableId = "tblLocations";
    }else if( searchParams.profileType == ctProfileTypeSportist ){
        tableId = "tblSportists";
    }    
    
    var tableColumns = [ "id" , "name" ];
    if(searchParams.profileType == ctProfileTypeEvent) tableColumns[ tableColumns.length ] = "date";
    if(searchParams.profileType == ctProfileTypeLocation) tableColumns[ tableColumns.length ] = "address";
    
    var ajaxRequest = ctBackendRootURL + "/list";
    if(searchParams.profileType == ctProfileTypeEvent){
        ajaxRequest += "Event";
    }else if(searchParams.profileType == ctProfileTypeSportist){
        ajaxRequest += "Sportist";
    }else if(searchParams.profileType == ctProfileTypeLocation){
        ajaxRequest += "Location";
    }
    
    var params = new Array();
    if( searchParams.name != undefined ) params[params.length] = "name=".concat(searchParams.name);
    if( searchParams.dateFrom != undefined ) params[params.length] = "dateFrom=".concat(searchParams.dateFrom);
    if( searchParams.dateTo != undefined ) params[params.length] = "dateTo=".concat(searchParams.dateTo);
    if( searchParams.address != undefined ) params[params.length] = "address=".concat(searchParams.address);
    for(paramIdx in params){
        if(paramIdx == 0){
            ajaxRequest += "?";
        }else{
            ajaxRequest += "&";
        }
        ajaxRequest += params[paramIdx];
    }
    
    gfLoadTableData( tableId, tableColumns, ajaxRequest, function(selectedId,selectedName){
        gotoProfileDetailPage( selectedId, searchParams.profileType );
    });
}