/*
 * Sportist management functions
 *
 * Requires:
 *  - appuntat.global.js
 *  - jquery.dataTables.js
 *  - jquery.ui.js
 */

// Loads the sportist data
// Requires:
// - the progress moda div "mdlProgress"
function smLoadSportistData( sportistId, callBack ){
    $.ajax({
        url: ctBackendRootURL + "/getSportist",
        data: { id: sportistId }
    }).then( callBack );
}

// Fills the info fields with the loaded user data in VIEW mode
var smShowDataInViewMode = function( response ){
    $('#fldSportistName').text(response.result.name);
    pmLoadPicture( response.result.pictureId , ctProfileTypeSportist );
}

// Fills the info fields with the loaded user data in EDIT mode
var smShowDataInEditMode = function( response ){
    $('#txtSportistName').val( response.result.name );
    pmLoadPicture( response.result.pictureId , ctProfileTypeSportist );
}

// Sets the visibility of the sportist specific elements
function smSetSportistOptionsVisibility(){
    // hide everything
    $('#divEdit').addClass("hide"); // link to edit the sportist profile
    $('#divInvite').addClass("hide"); // link to invite the sportist to an existing event
    $('#divSearch').addClass("hide"); // link to search page
    // show only what's allowed
    if( gfGetGlobalValue( ctKeyProfileType ) == ctProfileTypeLocation ){
        // profile opened by a location
        $('#divInvite').removeClass("hide");
    }else{
        // profile opened by a sportist
        var urlParams = gfQueryStringToJSON( location.search.slice(1) );
        if( pmProfileViewerIsItsManager() ){
            // logged sportist is the manager of the profile being shown
            $('#divEdit').removeClass("hide");
            $('#divSearch').removeClass("hide");
        }
    }
}

// Saves the changes done to the sportist
function smUpdateSportist(){
    $( "#divProgressBar" ).progressbar({ value: 25 });
    var profileId = gfGetGlobalValue( ctKeyProfileId );
    var formAction = ctBackendRootURL + "/updateSportist";
    var formData = {
        id: profileId,
        name: $('#txtSportistName').val(),
    }
    $.post( formAction, formData, smUpdateSportistCallback );
}
var smUpdateSportistCallback = function( response ){
    $( "#divProgressBar" ).progressbar({ value: 75 });
    if($.isEmptyObject( response.result )){
        gfShowMessage( "No s'ha pogut actualitzar el perfil: " + response.errorMessage, true );
    }else{
        gotoProfileDetailPage( gfGetGlobalValue( ctKeyProfileId ), ctProfileTypeSportist )
    }
};
