/*
 * User management functions
 *
 * Requires:
 *  - appuntat.global.js
 *  - appuntat.profile.js
 *  - jquery.ui.js
 */

// User creation
// Requires:
//  - a div "divProgressBar" with a progress bar in it
//  - the form with the user data
function umCreateUser(){
    $( "#divProgressBar" ).progressbar({ value: 10 });
    var formAction = ctBackendRootURL + "/updateUser";
    var formData = {
        mail: $('#txtRegisterMail').val(),
        password: $('#pwdRegisterPassword').val()
    }
    $.post( formAction, formData, umCreateUserCallback );
};
var umCreateUserCallback = function( response ){
    $( "#divProgressBar" ).progressbar({ value: 30 });
    if($.isEmptyObject( response.result )){
        gfShowMessage( "No s'ha pogut crear l'usuari: " + response.errorMessage, true );
    }else{
        pmCreateProfile( response.result.id );
    }
};

// User check (login)
// Requires:
//  - a div "divProgressBar" with a progress bar in it
//  - the form with the user login data
function umLogin(){
    $( "#divProgressBar" ).progressbar({ value: 10 });
    var formAction = ctBackendRootURL + "/login";
    var formData = {
        mail: $('#txtLoginMail').val(),
        password: $('#pwdLoginPassword').val()
    }
    $.post( formAction, formData, umLoginCallback );
};
var umLoginCallback = function( response ){
    $( "#divProgressBar" ).progressbar({ value: 80 });
    if($.isEmptyObject( response.result )){
        gfShowMessage( "No s'ha pogut validar l'usuari: " + response.errorMessage, true );
    }else{
        gfSetGlobalValue( ctKeySessionId , response.result.sessionId );
        gfSetGlobalValue( ctKeyUserId , response.result.userId );
        gfSetGlobalValue( ctKeyProfileId , response.result.profileId );
        gfSetGlobalValue( ctKeyProfileType , response.result.profileType );
        pmGotoProfileHome();
    }
};

// User log out
// Requires:
//  - a div "divProgressBar" with a progress bar in it
//  - the logout link
function umLogout(){
    $( "#divProgressBar" ).progressbar({ value: 10 });
    var formAction = ctBackendRootURL + "/logout";
    var formData = {
        sessionId: gfGetGlobalValue( ctKeySessionId )
    }
    $.post( formAction, formData, umLogoutCallback );
};
var umLogoutCallback = function( response ){
    if($.isEmptyObject( response.errorMessage ) == false){
        console.error( response.errorMessage );
    }
    gfClearGlobalValues();
    gotoIndex();
};

// Sets the visibility of the user options (register, login, logout)
// Requires:
//  - the section "secUserOpts" containing the user options
function umSetUserOptionsVisibility(){
    if( gfGetGlobalValue( ctKeySessionId ) === null ){
        $( "#secLogIn" ).removeClass("hide");
        $( "#secLogOut" ).addClass("hide");
    }else{
        $( "#secLogIn" ).addClass("hide");
        $( "#secLogOut" ).removeClass("hide");
    }
}
